/***************************************************************************/
/**                           M-DPM-12 TASK                               **/
/**                                                                       **/
/**  Installationshinweise:                                               **/
/**                                                                       **/
/**  Programmnummer  : 329h                                               **/
/**  Tasknummer      : beliebig                                           **/
/**  Interruptquelle : 1 (wird nicht verwendet, da NI-Task)               **/
/**  Datenbereich    : 0                                                  **/
/**  Flags           : 0180h (nicht aktivieren)                           **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**                     Fr Borland C++ (Version 3.1)                     **/
/**                                                                       **/
/**                             Version 1.B.                              **/
/**                                                                       **/
/**                   Erstellungsdatum : 15.08.96                         **/
/**                    letzte nderung : 23.09.96                         **/
/**                             Status : O.K.                             **/
/**                              Autor : A. Horst                         **/
/**                                                                       **/
/**                (c) 1996 SORCUS Computer GmbH Heidelberg               **/
/**                                                                       **/
/***************************************************************************/

#pragma option -r-                     /* no registervars                  */
#pragma option -k                      /* standard stackframe              */

#include "ml8rtbib.h"
#include "mlxmacro.h"
#include "dos.h"
#include "stdlib.h"


#include "m044_lib.h"
#include "m044task.h"

#define PROGRAMM_NUMBER 0x329
#define VERSION         '1'
#define REVISION        'B'


void auto_init(void)
{
 ml8rt_entry();
 ml8rt_exit();
}


void main_task()
{
 ml8rt_entry();
 ml8rt_exit();
}


void init_pdt()
{
 pdt.typ = 1;
 pdt.proc_num = 33;
 pdt.lengt = _PDT_LENGTH;
 pdt.prg_number = PROGRAMM_NUMBER;
 pdt.version = VERSION;
 pdt.revision = REVISION;
 pdt.cpu_type = _486DX;
 pdt.coproz_type = _NOCOPROZ;
 pdt.language = _CPP31;
 pdt.prg_type = _USER_PRG;
 pdt.flags = _NI_TASK + _LOCAL_DATA + _LOCAL_PARAMETER + _FIXED_DATASIZE + _PDT_INFO_ENABLE ;
 pdt.interrupt_num = 0;
 pdt.data_adr = 0;
 pdt.data_size = 0;
 pdt.data_min = 0;
 pdt.data_max = 0;

 ml8rt_phys_adr(&parameter, &pdt.parameter_adr);
 pdt.parameter_adr = pdt.parameter_adr + sizeof(tdt_type);

 pdt.parameter_size = sizeof(parameter) - sizeof(tdt_type);
 pdt.hyper_adr = 0;
 pdt.main_proc = main_task;                                             // 0
 pdt.auto_init = auto_init;                                             // 1
 pdt.m044rt_bib_startup = m044rt_bib_startup;                           // 2
 pdt.m044rt_configure = m044rt_configure;                               // 3
 pdt.m044rt_get_master_mode = m044rt_get_master_mode;                   // 4
 pdt.m044rt_restart = m044rt_restart;                                   // 5
 pdt.m044rt_refresh_slave_datastruct = m044rt_refresh_slave_datastruct; // 6
 pdt.m044rt_get_slave_datastruct = m044rt_get_slave_datastruct;         // 7
 pdt.m044rt_check_slave_active = m044rt_check_slave_active;             // 8
 pdt.m044rt_get_slave_byte = m044rt_get_slave_byte;                     // 9
 pdt.m044rt_get_slave_word = m044rt_get_slave_word;                     // 10
 pdt.m044rt_get_slave_block = m044rt_get_slave_block;                   // 11
 pdt.m044rt_set_slave_byte = m044rt_set_slave_byte;                     // 12
 pdt.m044rt_set_slave_word = m044rt_set_slave_word;                     // 13
 pdt.m044rt_set_slave_block = m044rt_set_slave_block;                   // 14
 pdt.m044rt_set_master_mode = m044rt_set_master_mode;                   // 15
 pdt.m044rt_watchdog_enable = m044rt_watchdog_enable;                   // 16
 pdt.m044rt_watchdog_retrigger = m044rt_watchdog_retrigger;             // 17
 pdt.m044rt_set_slave_address = m044rt_set_slave_address;               // 18
 pdt.m044rt_set_slave_command = m044rt_set_slave_command;               // 19
 pdt.m044rt_get_slave_diagnosis_list =  m044rt_get_slave_diagnosis_list;// 20
 pdt.m044rt_check_slave_diagnosis = m044rt_check_slave_diagnosis;       // 21
 pdt.m044rt_get_slave_diagnosis = m044rt_get_slave_diagnosis;           // 22
 pdt.m044rt_get_data_transfer_list = m044rt_get_data_transfer_list;     // 23
 pdt.m044rt_get_master_status_struct = m044rt_get_master_status_struct; // 24
 pdt.m044rt_get_system_error_struct = m044rt_get_system_error_struct;   // 25
 pdt.m044rt_poll_system_error = m044rt_poll_system_error;               // 26
 pdt.m044rt_download = m044rt_download;                                 // 27
 pdt.m044rt_upload = m044rt_upload;                                     // 28
 pdt.m044rt_hard_reset = m044rt_hard_reset;                             // 29
 pdt.m044rt_reset_master = m044rt_reset_master;                         // 30
 pdt.m044rt_get_error = m044rt_get_error;                               // 31
 pdt.m044rt_fw_timer = m044rt_fw_timer;                                 // 32
}


void main()
{
 init_pdt();
 ml8rt_set_pdt_adr(&pdt);
}


// 2, checked
void far pascal m044rt_bib_startup(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();
 DISABLE_INT;

 task = task;
 insize = insize;
 indata = indata;
 outdata = outdata;

 if(parameter.status == 0)
   parameter.status = m044_bib_startup();

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 3, checked
void far pascal m044rt_configure(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(parameter.status == 0)
   {
    parameter.status = m044_configure(indata[0]);
    if(parameter.status == 0)
      {
       parameter.microslot = indata[0];/* save microslot                   */
      }
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 4, checked
void far pascal m044rt_get_master_mode(ushort task,
				       ushort insize, byte *indata,
				       ushort outsize, byte *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_get_master_mode(indata[0], outdata);
   }

 outsize = 1;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 5, checked
void far pascal m044rt_restart(ushort task, ushort insize, byte *indata,
			       ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_restart(indata[0],
				    indata[1]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 6, checked
void far pascal m044rt_refresh_slave_datastruct(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_refresh_slave_datastruct(indata[0]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}

// 7, checked
void far pascal m044rt_get_slave_datastruct(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, m044_slv_datastr_type *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
     parameter.status = m044_get_slave_datastruct(indata[0],
			                          indata[1],
			                          outdata);
   }

 outsize = sizeof(m044_slv_datastr_type);
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}




// 8, checked
void far pascal m044rt_check_slave_active(ushort task, ushort insize, byte *indata,
					  ushort outsize, byte *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_check_slave_active(indata[0], indata[1], outdata);
   }

 outsize = 1;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 9, checked
void far pascal m044rt_get_slave_byte(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_get_slave_byte(indata[0],
			                   indata[1],
				           indata[2],
				           outdata,
				           indata[4]);
   }

 outsize = 1;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 10, checked
void far pascal m044rt_get_slave_word(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)
   {
    parameter.status = m044_get_slave_word(indata[0],
				           indata[1],
				           indata[2],
				           outdata,
				           indata[4]);
   }

 outsize = 2;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 11, checked
void far pascal m044rt_get_slave_block(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)
   {
    parameter.status = m044_get_slave_block(indata[0],
				            indata[1],
				            (ushort)(((ushort)indata[3] << 8) + indata[2]),
				            indata[4],
				            outdata,
				            indata[5]);
   }

 outsize = indata[4];
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 12, checked
void far pascal m044rt_set_slave_byte(
			ushort task,
			ushort insize, byte *indata,
                        ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)
   {
    parameter.status = m044_set_slave_byte(indata[0],
				           indata[1],
				           indata[2],
				           indata[3],
				           indata[4]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 13, checked
void far pascal m044rt_set_slave_word(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_set_slave_word(indata[0],
    				           indata[1],
				           indata[2],
				           (ushort)(((ushort)indata[4] << 8) + indata[3]),
				           indata[5]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 14, checked
void far pascal m044rt_set_slave_block(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_set_slave_block(indata[0],
				            indata[1],
				            (ushort)(((ushort)indata[3] << 8) + indata[2]),
				            indata[4],
				            &indata[6],
				            indata[5]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 15, checked
void far pascal m044rt_set_master_mode(
                        ushort task,
                        ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();              /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_set_master_mode(indata[0], indata[1]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 16, checked
void far pascal m044rt_watchdog_enable(
                        ushort task,
                        ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_watchdog_enable(indata[0],
                                            (ushort)((ushort)indata[2] << 8) + indata[1]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 17, checked
void far pascal m044rt_watchdog_retrigger(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_watchdog_retrigger(indata[0]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 18, checked
void far pascal m044rt_set_slave_address(
			ushort task,
                        ushort insize, byte *indata,
                        ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)
   {
    parameter.status = m044_set_slave_address(indata[0],
			                      (byte *)&indata[2],
		          		      indata[1]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 19, checked
void far pascal m044rt_set_slave_command(
                        ushort task,
                        ushort insize, byte *indata,
                        ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();              /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_set_slave_command(indata[0],
				              indata[1],
				              indata[2],
				              indata[3]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 20, checked
void far pascal m044rt_get_slave_diagnosis_list(
                        ushort task,
                        ushort insize, byte *indata,
                        ushort outsize, byte *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_get_slave_diagnosis_list(indata[0],
                                                     (m044_slv_bitmap_type *)outdata);
   }

 outsize = sizeof(m044_slv_bitmap_type);
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 21, checked
void far pascal m044rt_check_slave_diagnosis(
			ushort task,
			ushort insize, byte *indata,
                        ushort outsize, byte *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_check_slave_diagnosis(indata[0], indata[1], outdata);
   }

 outsize = 1;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 22, checked
void far pascal m044rt_get_slave_diagnosis(
                        ushort task, ushort insize, byte *indata,
                        ushort outsize, byte *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_get_slave_diagnosis(indata[0],
                                     indata[1],
                                     indata[2],
                                     outdata);
   }

 outsize = indata[2];
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 23, checked
void far pascal m044rt_get_data_transfer_list(
                        ushort task,
                        ushort insize, byte *indata,
                        ushort outsize, byte *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_get_data_transfer_list(indata[0],
                                                   (m044_slv_bitmap_type *)outdata);
   }

 outsize = sizeof(m044_slv_bitmap_type);
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}



// 24, checked
void far pascal m044rt_get_master_status_struct(
                        ushort task,
                        ushort insize, byte *indata,
                        ushort outsize, m044_mst_statusstr_type *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_get_master_status_struct(indata[0], outdata);
   }

 outsize = sizeof(m044_mst_statusstr_type);
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 25, checked
void far pascal m044rt_get_system_error_struct(
                        ushort task,
                        ushort insize, byte *indata,
                        ushort outsize, m044_mst_syserr_type *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_get_system_error_struct(*indata, outdata);
   }

 outsize = sizeof(m044_mst_syserr_type);
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 26, checked
void far pascal m044rt_poll_system_error(
                        ushort task,
                        ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_poll_system_error(indata[0], outdata);
   }

 outsize = 2;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}



// 27
void far pascal m044rt_download(
                        ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata)
{
 int error;

 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 if((parameter.status == 0) || (parameter.status == 0x41E0))
   {
    if(indata[3] == 0)                 /* 1. block                         */
      {                                /* check status                     */
       if(parameter.status == 0)
	 {
	  m044_set_modul_register(indata[0], _M044_LER, 0x0F);
	  parameter.status = 0x41E0;
	 }
       else
	 {                             /* ERROR=41h, download in progress  */
	  error = 0x41E0;
	  outsize = 0;
	  *outdata = 0;
	  ENABLE_INT;
	  ml8rt_exit_function(0, outsize, error);
	 }
      }
   }
 error = m044_download(indata[0],  // microslot
		       &indata[4], // *data
		       indata[1],  // size
		       indata[2]); // flag

 if(error == 0)
   {
    if(indata[2] == _M044_NO_MORE_DATA)
      {
       parameter.status = 0;
       m044_set_modul_register(indata[0], _M044_LER, 0x03);
      }
   }
 else
   {
    parameter.status = error;
   }
 
 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, error);
}


// 28, checked
void far pascal m044rt_upload(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata)
{
 int error;
 byte flag, size;

 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;

 if((parameter.status == 0) || (parameter.status == 0x41E0))
   {
    if(indata[1] == _M044_START_DATA)  /* 1. block                         */
      {                                /* check status                     */
       if(parameter.status == 0)
	 {
	  parameter.status = 0x41E0;
	  m044_set_modul_register(indata[0], _M044_LER, 0x0F);
	 }
       else
	 {                            /* ERROR = 1, upload in progress     */
	  *outdata = 0;
	  outsize = 0;
	  error = 0x41E0;
	  ENABLE_INT;
	  ml8rt_exit_function(0, outsize, error);
	 }

    }
  size = 0;
  flag = indata[1];

  error = m044_upload(indata[0],
		      outdata,
		      &size,
		      &flag);
  if(error == 0)
    {
     if(flag == _M044_NO_MORE_DATA)
       {
	parameter.status = 0;
	m044_set_modul_register(indata[0], _M044_LER, 0x03);
       }
    }
  else parameter.status = error;
 }

 outsize = size + 2;
 outdata[outsize - 2] = size;
 outdata[outsize - 1] = flag;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, error);
}


// 29, checked
void far pascal m044rt_hard_reset(
                        ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 parameter.status = 0;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)
   {
    m044_set_modul_register(indata[0], _M044_LER, 0x03);

    parameter.status = m044_hard_reset(indata[0]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}


// 30, checked
void far pascal m044rt_reset_master(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 parameter.status = 0;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)
   {

    m044_set_modul_register(indata[0], _M044_LER, 0x03);

    parameter.status = m044_reset_master(indata[0]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}

// 31, checked
void far pascal m044rt_get_error(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;
 if(parameter.status == 0x40e0) parameter.status = 0;
 m044_get_error(indata[0], outdata);

 outsize = 20;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}
// 32, checked
void far pascal m044rt_fw_timer(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata)
{
 ml8rt_entry_function();               /* Save and prepare registers       */
 DISABLE_INT;

 task = task;
 insize = insize;
 outdata = outdata;

 if(indata[0] != parameter.microslot)
   parameter.status = 0x1BE0;          /* wrong slot                       */

 if(parameter.status == 0)             /* ERROR, down/upload in progress   */
   {
    parameter.status = m044_fw_timer(indata[0],
				     (ushort)((ushort)indata[2] << 8) + indata[1]);
   }

 outsize = 0;
 ENABLE_INT;
 ml8rt_exit_function(0, outsize, parameter.status);
}

