#define ENABLE_INT asm popf
#define DISABLE_INT asm{pushf; cli}


struct pdt_type
{
 unsigned char         typ;
 unsigned char         lengt;
 unsigned int          proc_num;
 unsigned int          prg_number;
 unsigned char         version;
 unsigned char         revision;

 unsigned char         cpu_type;
 unsigned char         coproz_type;
 unsigned char         language;
 unsigned char         prg_type;

 unsigned int          flags;
 unsigned int          interrupt_num;

 unsigned long         data_adr;
 unsigned long         data_size;
 unsigned long         data_min;
 unsigned long         data_max;

 unsigned long         parameter_adr;
 unsigned int          parameter_size;

 unsigned long         hyper_adr;
 unsigned int          res1;
 unsigned long         res2;

 void                  (*main_proc)();                        // 0
 void                  (*auto_init)();                        // 1
 void far pascal       (*m044rt_bib_startup)();               // 2
 void far pascal       (*m044rt_configure)();                 // 3
 void far pascal       (*m044rt_get_master_mode)();           // 4
 void far pascal       (*m044rt_restart)();                   // 5
 void far pascal       (*m044rt_refresh_slave_datastruct);    // 6
 void far pascal       (*m044rt_get_slave_datastruct);        // 7
 void far pascal       (*m044rt_check_slave_active);          // 8
 void far pascal       (*m044rt_get_slave_byte);              // 9
 void far pascal       (*m044rt_get_slave_word);              // 10
 void far pascal       (*m044rt_get_slave_block);             // 11
 void far pascal       (*m044rt_set_slave_byte);              // 12
 void far pascal       (*m044rt_set_slave_word);              // 13
 void far pascal       (*m044rt_set_slave_block);             // 14
 void far pascal       (*m044rt_set_master_mode);             // 15
 void far pascal       (*m044rt_watchdog_enable);             // 16
 void far pascal       (*m044rt_watchdog_retrigger);          // 17
 void far pascal       (*m044rt_set_slave_address);           // 18
 void far pascal       (*m044rt_set_slave_command);           // 19
 void far pascal       (*m044rt_get_slave_diagnosis_list);    // 20
 void far pascal       (*m044rt_check_slave_diagnosis);       // 21
 void far pascal       (*m044rt_get_slave_diagnosis);         // 22
 void far pascal       (*m044rt_get_data_transfer_list);      // 23
 void far pascal       (*m044rt_get_master_status_struct);    // 24
 void far pascal       (*m044rt_get_system_error_struct);     // 25
 void far pascal       (*m044rt_poll_system_error);           // 26
 void far pascal       (*m044rt_download);                    // 27
 void far pascal       (*m044rt_upload);                      // 28
 void far pascal       (*m044rt_hard_reset);                  // 29
 void far pascal       (*m044rt_reset_master);                // 30
 void far pascal       (*m044rt_get_error);                   // 31
 void far pascal       (*m044rt_fw_timer);                    // 32
}pdt;

struct parameter_type
{
 tdt_type              tdt;
 ushort                status;
 byte		       microslot;
 ushort		       error;
}parameter;


void auto_init(void);
void main_task(void);
void init_pdt(void);
void far pascal m044rt_bib_startup(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_configure(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_get_master_mode(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata);

void far pascal m044rt_restart(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_refresh_slave_datastruct(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata);

void far pascal m044rt_get_slave_datastruct(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, m044_slv_datastr_type *outdata);

void far pascal m044rt_check_slave_active(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata);

void far pascal m044rt_get_slave_byte(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata);

void far pascal m044rt_get_slave_word(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_get_slave_block(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata);

void far pascal m044rt_set_slave_byte(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_set_slave_word(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_set_slave_block(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_set_master_mode(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_watchdog_enable(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_watchdog_retrigger(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_set_slave_address(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_set_slave_command(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_get_slave_diagnosis_list(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata);

void far pascal m044rt_check_slave_diagnosis(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata);

void far pascal m044rt_get_slave_diagnosis(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata);

void far pascal m044rt_get_data_transfer_list(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize,	byte *outdata);


void far pascal m044rt_get_master_status_struct(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, m044_mst_statusstr_type *outdata);


void far pascal m044rt_get_system_error_struct(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, m044_mst_syserr_type *outdata);


void far pascal m044rt_poll_system_error(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_download(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata);


void far pascal m044rt_upload(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, byte *outdata);

void far pascal m044rt_hard_reset(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_reset_master(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_get_error(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);

void far pascal m044rt_fw_timer(
			ushort task,
			ushort insize, byte *indata,
			ushort outsize, ushort *outdata);
