/***************************************************************************/
/**                           M-DPM-12 TASK                               **/
/**                                                                       **/
/**  Installationshinweise:                                               **/
/**                                                                       **/
/**  Programmnummer  : 330h                                               **/
/**  Tasknummer      : beliebig                                           **/
/**  Interruptquelle : 1 (wird nicht verwendet, da NI-Task)               **/
/**  Datenbereich    : 0                                                  **/
/**  Flags           : 0980h (nicht aktivieren, Auto-Init aufrufen        **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**                     Fuer Borland C++ (Version 3.1)                    **/
/**                                                                       **/
/**                             Version 1.B                               **/
/**                                                                       **/
/**                   Erstellungsdatum : 15.08.96                         **/
/**                    letzte Aenderung : 19.09.96                        **/
/**                             Status : --------                         **/
/**                              Autor : A. Horst                         **/
/**                                                                       **/
/**                (c) 1996-99 SORCUS Computer GmbH Heidelberg            **/
/**                                                                       **/
/***************************************************************************/
/*                                                                         */
/* This task is an example for the usage of the M044TASK for the PROFIBUS  */
/* module M-DPM-12. The LEDs of the module are switched depending on the   */
/* actual status of the system (m044_poll_system_error):                   */
/*                                                                         */
/*                                                                         */
/*                       LED 2   LED 1                                     */
/*                       --------------------------------------            */
/*                       off     off      ERROR, Task running ?            */
/*                       on      off      STOP                             */
/*                       on      on       CLEAR                            */
/*                       off     on       OPERATE                          */
/*                       blink   blink    STATUS-ERROR                     */
/*                                                                         */
/* Before starting the task (ml8_call_proc(tasknum, 2)), the parameters    */
/* (x) must be set :                                                           */
/*        byte      .status    = actual PROFIBUS status                    */
/*        ushort    .error     = error calling function                    */
/*    x   byte      .microslot = M-DPM-12 Slot (1..10)                     */
/*    x   ushort    .tasknum   = number of task M044TASK.EXE               */
/*                                                                         */
/***************************************************************************/

#pragma option -r-                     /* no registervars                  */
#pragma option -k                      /* standard stackframe              */

#include "ml8rtbib.h"
#include "dos.h"
#include "stdlib.h"
#include "m044_lib.h"
#include "m044test.h"

#define PROGRAMM_NUMBER 0x330
#define VERSION         '1'
#define REVISION        'B'

void auto_init(void)
{
 ml8rt_entry();
 ml8rt_exit();
}

void start(void)
{
 ml8rt_entry();
 m044_set_tasknum(parameter.tasknum);
 parameter.counter = 0x0fff;
 ml8rt_local_led_off();
 parameter.error = m044_bib_startup();
 parameter.error = m044_configure(parameter.microslot);
 parameter.error = m044_reset_master(parameter.microslot);

 do parameter.error = m044_get_master_mode(parameter.microslot, &parameter.status);
 while(parameter.status != _M044_STOP);

 if(parameter.status == _M044_STOP)
	{
	 ml8rt_local_led_on();
	 parameter.error = m044_set_master_mode(parameter.microslot, _M044_OPERATE);
	 parameter.error = m044_get_master_mode(parameter.microslot, &parameter.status);
	 if(parameter.status == _M044_OPERATE)
		{
		 parameter.error = m044_refresh_slave_datastruct(parameter.microslot);
		 ml8rt_wakeup_task(parameter.tdt.task);/* wake up this task                */
		}
	}
	ml8rt_exit();
}


void stop(void)
{
 ml8rt_entry();
 parameter.error = m044_set_master_mode(parameter.microslot, _M044_STOP);
 ml8rt_sleep_task(parameter.tdt.task); /* stop this task                   */
 parameter.error = m044_get_master_mode(parameter.microslot, &parameter.status);
 m044_set_modul_register(parameter.microslot, _M044_LER, 0x0B);
 ml8rt_exit();
}


void main_task()
{
	ushort syserr;

	ml8rt_entry();
	parameter.error = m044_poll_system_error(parameter.microslot, &syserr);
	if(!parameter.error)
		parameter.error = m044_get_master_mode(parameter.microslot, &parameter.status);

	if(parameter.error || syserr)
	{
	 if(--parameter.counter == 0)
		{
			if(m044_get_modul_register(parameter.microslot, _M044_LER) == 0x01)
				m044_set_modul_register(parameter.microslot, _M044_LER, 0x0B);
			else
				m044_set_modul_register(parameter.microslot, _M044_LER, 0x07);
			parameter.counter = 0x0fff;
		}
	}
	else
	{
	 switch(parameter.status)
		{
		 case 0xC0: m044_set_modul_register(parameter.microslot, _M044_LER, 0x07);
		  break;
		 case 0x80: m044_set_modul_register(parameter.microslot, _M044_LER, 0x0F);
		  break;
		 case 0x40: m044_set_modul_register(parameter.microslot, _M044_LER, 0x0B);
		  break;
		 default  : m044_set_modul_register(parameter.microslot, _M044_LER, 0x03);
		}
	}
	ml8rt_exit();
}

void main()
{
 pdt.typ = 1;
 pdt.proc_num = 4;
 pdt.lengt = _PDT_LENGTH;
 pdt.prg_number = PROGRAMM_NUMBER;
 pdt.version = VERSION;
 pdt.revision = REVISION;
 pdt.cpu_type = _486DX;
 pdt.coproz_type = _NOCOPROC;
 pdt.language = _CPP31;
 pdt.prg_type = _USER_PRG;
 pdt.flags = _NI_TASK + _LOCAL_DATA + _LOCAL_PARAMETER;
 pdt.interrupt_num = 0;
 pdt.data_adr = 0;
 pdt.data_size = 0;
 pdt.data_min = 0;
 pdt.data_max = 0;
 ml8rt_phys_adr(&parameter, &pdt.parameter_adr);
 pdt.parameter_adr = pdt.parameter_adr + sizeof(tdt_type);
 pdt.parameter_size = sizeof(parameter) - sizeof(tdt_type);
 pdt.hyper_adr = 0;
 pdt.main_proc = main_task;            // 0
 pdt.auto_init = auto_init;            // 1
 pdt.start     = start;                // 2
 pdt.stop      = stop;                 // 3
 ml8rt_set_pdt_adr(&pdt);
}




